<template>
  <div style="width: 100%">
    <div class="education">
      <div class="education-title"><b>Омӯзишҳои</b> шумо</div>
      <div class="education-list">
        <div class="education-list__item">
          <div class="education-list__item-inner">
            <span>
              {{
                exercises_list_done.filter(
                  (el) => el.type_exercise == "Чорабиниҳо"
                ).length
              }}
            </span>
            <p>
              <b> Чорабиниҳои </b><br />
              таҳқиқшуда
            </p>
          </div>
          <div class="education-list__item-inner">
            <span>
              {{
                exercises_list_done.filter(
                  (el) => el.type_exercise == "Такмили ихтисос"
                ).length
              }}
            </span>
            <p>
              <b> Такмили ихтисоси </b><br />
              ба анҷомрасида
            </p>
          </div>
          <div class="education-list__item-inner">
            <span>
              {{
                exercises_list_done.filter(
                  (el) => el.type_exercise == "Маводҳо"
                ).length
              }}
            </span>
            <p>
              <b> Маводҳо </b><br />
              аз назар гузарондашуда
            </p>
          </div>
        </div>
        <div class="education-list__item">
          <div class="education-list__item-inner">
            <span>{{ count_of_credits(exercises_list_done) }}</span>
            <p>
              <b> Соатҳои кредитӣ </b><br />
              гирифта шудаанд
            </p>
          </div>
        </div>
      </div>

      <accordion v-if="exercises_list_canceled.length > 0">
        <template v-slot:title>
          <div class="education-desc">
            Рӯйхати супоришҳое, ки аз санҷиш нагузаштаанд:
          </div>
        </template>
        <template v-slot:content>
          <div class="education-wrapper">
            <Exercise
              :item="exercise"
              v-for="exercise in exercises_list_canceled"
              :key="exercise._id"
              :access="exercise.access"
            />
          </div>
        </template>
      </accordion>
      <accordion v-if="exercises_list_done.length > 0">
        <template v-slot:title>
          <div class="education-desc">
            Рӯйхати супоришҳое, ки аз санҷиш гузаштаанд:
          </div>
        </template>
        <template v-slot:content>
          <div class="education-wrapper">
            <Exercise
              :item="exercise"
              v-for="exercise in exercises_list_done"
              :key="exercise._id"
              :access="exercise.access"
            />
          </div>
        </template>
      </accordion>
      <accordion v-if="exercises_list_pending.length > 0">
        <template v-slot:title>
          <div class="education-desc">
            Рӯйхати супоришҳое, ки дар рафти санҷиш қарор доранд:
          </div>
        </template>
        <template v-slot:content>
          <div class="education-wrapper">
            <Exercise
              :item="exercise"
              v-for="exercise in exercises_list_pending"
              :key="exercise._id"
              :access="exercise.access"
            />
          </div>
        </template>
      </accordion>
      <accordion v-if="exercises_list_have_access.length > 0">
        <template v-slot:title>
          <div class="education-desc">
            Рӯйхати супоришҳое, ки барои супоридан иҷоза дода шудааст:
          </div>
        </template>
        <template v-slot:content>
          <div class="education-wrapper">
            <Exercise
              :item="exercise"
              v-for="exercise in exercises_list_have_access"
              :key="exercise._id"
              :access="exercise.access"
            />
          </div>
        </template>
      </accordion>
      <accordion v-if="exercises_list_no_access.length > 0">
        <template v-slot:title>
          <div class="education-desc">
            Рӯйхати супоришҳое, ки дар ҳолати интизории баррасӣ қарор доранд:
          </div>
        </template>
        <template v-slot:content>
          <div class="education-wrapper">
            <Exercise
              :item="exercise"
              v-for="exercise in exercises_list_no_access"
              :key="exercise._id"
              :access="exercise.access"
            />
          </div>
        </template>
      </accordion>
    </div>
  </div>
</template>

<script>
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      exercises_list_have_access: [],
      exercises_list_no_access: [],
      exercises_list_pending: [],
      exercises_list_done: [],
      exercises_list_canceled: [],
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getExercises();
  },
  computed: {
    count_of_credits() {
      return (list) => {
        let count = 0;
        list.forEach((item) => {
          count += parseInt(item.credit);
        });
        return count;
      };
    },
  },
  methods: {
    goToExercise(url) {
      this.$router.push(url);
    },
    getExercises() {
      this.$axios
        .$post("/exercise/getUserExercises", { user_id: this.$auth.user._id })
        .then(
          ({
            exercises_list_have_access,
            exercises_list_no_access,
            exercises_penging,
            exercises_done,
            exercises_canceled,
          }) => {
            if (exercises_penging.length > 0) {
              this.exercises_list_pending = exercises_penging;
            }
            if (exercises_done.length > 0) {
              this.exercises_list_done = exercises_done;
            }
            if (exercises_list_have_access.length > 0) {
              this.exercises_list_have_access = exercises_list_have_access;
            }
            if (exercises_list_no_access.length > 0) {
              this.exercises_list_no_access = exercises_list_no_access;
            }
            if (exercises_canceled.length > 0) {
              this.exercises_list_canceled = exercises_canceled;
            }
            // exercises.forEach((exercise) => {
            //   exercise.applications.forEach((applications) => {
            //     if (
            //       applications.access === true &&
            //       applications.id === this.$auth.user._id
            //     ) {
            //       this.exercises_list_have_access.push(exercise);
            //     }
            //     if (
            //       applications.access === false &&
            //       applications.id === this.$auth.user._id
            //     ) {
            //       this.exercises_list_no_access.push(exercise);
            //     }
            //   });
            // });
          }
        )
        .catch((error) => {
          console.log(error);
        });
    },
    downloadGradeBook() {
      this.$html2pdf(this.$refs.document, {
        margin: 1,
        filename: "file-name.pdf",
        image: { type: "jpeg", quality: 1 },
        html2canvas: {
          scale: 1,
          dpi: 192,
          letterRendering: true,
          ignoreElements: true,
        },
        jsPDF: { unit: "pt", format: "a2", orientation: "portrait" },
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.education {
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  width: 100%;
  min-height: 80vh;
  @include less-than(tablet) {
    min-height: 0vh;
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    width: 100%;
    b {
    }
  }

  &-desc {
    line-height: 1.3;
    font-size: 24px;

    @include less-than(tablet) {
      font-size: 18px;
    }
  }

  &-wrapper {
    padding-top: 10px;
    padding-bottom: 20px;
    display: grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-gap: 20px;
    text-align: left;
    align-items: center;
    @include less-than(tablet) {
      grid-template-columns: 1fr;
    }
  }

  &-list {
    display: flex;
    flex-wrap: wrap;
    flex-direction: column;
    transition: all ease 0.3s;
  }
  &-list__item {
    position: relative;
    padding: 35px;
    background: #fff;
    border-bottom: 1px solid #ccc;
    transition: all ease 0.3s;
    // cursor: pointer;
    font-size: 20px;
    margin-bottom: 20px;
    top: 0;
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    text-align: left;
    grid-gap: 20px;
    &:nth-last-child(1) {
      border-bottom: none;
    }
    @include less-than(tablet) {
      font-size: 13px;
      padding: 20px 30px;
      min-height: fit-content;
      grid-template-columns: repeat(1, 1fr);
    }
    b {
      font-family: "Montserrat-Bold";
    }
  }
  &-list__item-inner {
    display: flex;
    height: fit-content;
    transition: all ease 0.3s;
    span {
      display: flex;
      font-size: 40px;
      font-family: "Montserrat-Bold";
      height: fit-content;
      &::after {
        content: "";
        left: 100%;
        width: 1px;
        height: 52px;
        margin: 0 20px;
        background: #dadbe2;
        -webkit-transform: skew(-15deg, 0);
        -moz-transform: skew(-15deg, 0);
        -ms-transform: skew(-15deg, 0);
        -o-transform: skew(-15deg, 0);
        transform: skew(-15deg, 0);
      }
    }
    p {
      height: fit-content;
    }
  }
  &-list__item-inner--hover:hover {
    color: #0c63e4;
  }
}
</style>
